/**************************************************
Copyright (A), 2023, DALIAN QIYUN DISPLAY Co., Ltd.
Description:Test GDC04557
Others:    Interface(SPI) 	 
           VDD;3.0V   	
Driver Card ICHT1621B
*************************************************/ 
#include<reg52.h>
#include <intrins.h>
/*AT89C52ӿڶ*************************************************/
sbit sda = P1^0;
sbit sck = P1^1;
sbit cs = P1^5;

/***************************************************************/
void Lcd_init(void);
void LcdDisplay_All(unsigned char ucAddrValue,ucDataValue,ucSegNum);
void LcdDisplay_Single(unsigned char ucAddrValue,ucDataValue);
void Lcd_Display(unsigned char Num_1,Num_2,Num_3,Num_4);
void SendNBitToRAM(unsigned char ucDataValue,ucBitNum);
void SendAddrToRAM(unsigned char ucAddrValue);
void delay(unsigned int ulCnt);     


#define LCD_MODE_CMD 0x80    						//ID룺100*****
#define LCD_MODE_WRITE 0xa0   					//ID룺101*****
#define SYS_EN 0x01    									//0000-0001-X(Turn on system oscillator) 
#define BIAS 0x29    										//0010-1001-X(BIAS 1/34COM)
#define LCD_DISPLAY_ON 0x03   					//0000-0011-X(Turn on LCD display)
#define LCD_SEG_NUM 8   								//ĻSEG

/************************************************************************
  PIN |   1    2    3    4   |   5    6    7    8    9   10   11    12  |
-------------------------------------------------------------------------
  SEG |  D0   D1   D2   D3   |  S0   S1   S2   S3   S4   S6   S6   S7   |
------------------------------------------------------------------------|
 COM0 | COM0   						   |  1A    C   2A   DP   3A   pH   4A   uS   |  
 COM1 |      COM1  					 |  1F   1B   2F   2B   3F   3B   4F   4B   |  
 COM2 |           COM2       |  1E   1G   2E   2G   3E   3G   4E   4G   |  
 COM3 |                COM3  |  1D   1C   2D   2C   3D   3C   4D   4C   |  
-------------------------------------------------------------------------
  ARR |  												00        02        04        06        | 
*************************************************************************/

/**********************ʾ*********************************/

#define Digit_0 0xf5    					//0
#define Digit_1 0x05    					//1
#define Digit_2 0xb6    					//2
#define Digit_3 0x97    					//3
#define Digit_4 0x47    					//4
#define Digit_5 0xd3    					//5
#define Digit_6 0xf3    					//6
#define Digit_7 0x85    					//7
#define Digit_8 0xf7    					//8
#define Digit_9 0xd7    					//9

#define DP 0x08    								//Сʾ
#define C 0x08    								//϶
#define pH 0x08    								//pH
#define uS 0x08    								//uS

#define LcdAll_On 0xff 						//ȫʾ
#define Off 0x00    							//ʾ

/**********************ַ*********************************/

#define Addr_Num1 0x00    			//һλֵַ
#define Addr_Num2 0x02    			//ڶλֵַ
#define Addr_Num3 0x04    			//λֵַ
#define Addr_Num4 0x06    			//λֵַ


/***************************************************************/
void main()
{
	while(1)
	{
		Lcd_init();  																			//ʼ
		LcdDisplay_All(0x00,LcdAll_On,LCD_SEG_NUM);     	//ȫʾ
		delay(1000);	   		
		LcdDisplay_All(0x00,Off,LCD_SEG_NUM);  						//
		delay(500);	
		LcdDisplay_All(0x00,LcdAll_On,LCD_SEG_NUM);     	//ȫʾ
		delay(1000);	   		
		LcdDisplay_All(0x00,Off,LCD_SEG_NUM);  						//
		delay(500);

		LcdDisplay_Single(Addr_Num1,Digit_4);  						//4
		delay(500);		
		LcdDisplay_Single(Addr_Num2,Digit_5);  						//45
		delay(500);		
		LcdDisplay_Single(Addr_Num2,Digit_5 + DP);  			//45.
		delay(500);		
		LcdDisplay_Single(Addr_Num3,Digit_5);  						//45.5
		delay(500);	
		LcdDisplay_Single(Addr_Num4,Digit_7);  						//45.57
		delay(500);		
		LcdDisplay_Single(Addr_Num1,Digit_4 + C);  				//45.57 C
		delay(500);	
		LcdDisplay_Single(Addr_Num3,Digit_5 + pH);  			//45.57 C pH
		delay(500);	
		LcdDisplay_Single(Addr_Num4,Digit_7 + uS);  			//45.57 C pH uS
		delay(1500);	

		Lcd_Display(Digit_6,Digit_0,Digit_2,Digit_3);			//60.23 C pH uS
		delay(1500);		
	}	
}


/**************************************************************
ʼ:HT1621ֲᣩ
**************************************************************/
void Lcd_init(void)
{
	cs=0;																//ƬѡѡHT1621
	SendNBitToRAM(LCD_MODE_CMD,3);			//ID
	SendNBitToRAM(SYS_EN,9);					  //ϵͳʱ
	SendNBitToRAM(BIAS,9);						  //ʽ趨4COM1/3ƫѹӦLCDĲ1/4 duty1/3 bias
	SendNBitToRAM(LCD_DISPLAY_ON,9);		//LCDƫ÷	
	cs=1;												        //ͷHT1621
} 

/***************************************************************
ݴͣУ
ucDataValueʾݡIDID롢ʼ룻
ucBitNumλĳȣIDID3λʾ8λ4λʼ9λ
****************************************************************/
void SendNBitToRAM(unsigned char ucDataValue,ucBitNum)
{
	unsigned char i;
	for(i=0;i<ucBitNum;i++)
	{
		if(ucDataValue&0x80)
				sda=1;
		else
				sda=0;
			sck=0;
			_nop_();
			_nop_();
			sck=1;
			_nop_();
			_nop_();
		  ucDataValue=ucDataValue<<1;				
	} 
}

/***************************************************************
ַ
****************************************************************/
void SendAddrToRAM(unsigned char ucAddrValue)
{
	unsigned char i;
		  ucAddrValue=ucAddrValue<<2;						//ַֻе6λҪƵλ
	for(i=0;i<6;i++)
	{
		if(ucAddrValue&0x80)
			sda=1;
		else
		  sda=0;
		sck=0;
		_nop_();
		_nop_();
		sck=1;
		_nop_();
		_nop_();
	  ucAddrValue=ucAddrValue<<1;	
	}
}
/***************************************************************/
void delay(unsigned int ulCnt)
{
	unsigned int i;
	while(ulCnt--)
	{
	for(i=100;i>0;i--);
	}
}
/***************************************************************/
/**************************************************************
ȫʾУ
ucAddrValueַ
ucDataValueʾ
ucSegNumSEGжٸSEGʹͶٴʾ
**************************************************************/
void LcdDisplay_All(unsigned char ucAddrValue,ucDataValue,ucSegNum)
{
	unsigned char i;

	cs=0;																//ƬѡѡHT1621
	SendNBitToRAM(LCD_MODE_WRITE,3);		//ID
	SendAddrToRAM(ucAddrValue);					//͵ַ
	for(i=0;i<ucSegNum;i++)						  //ʾݵʱ򣬵ַԶһ
	{			
		SendNBitToRAM(ucDataValue,8);			//ʾ
	}
	cs=1;												        //ͷHT1621
}



/********************************************************************************
																						 SEGN  |  SEGN+1
		 dataID          add          datCOM1COM2COM3COM4|COM1COM2COM3COM4
      101        A5A4A3A2A1A0                D0D1D2D3  |  D4D5D6D7

**********************************************************************************/

/*************************ʾ**************************************/

void LcdDisplay_Single(unsigned char ucAddrValue,ucDataValue)
{
	cs=0;																		//ƬѡѡHT1621

	SendNBitToRAM(LCD_MODE_WRITE,3);				//ID
	SendAddrToRAM(ucAddrValue);							//͵ַ
	SendNBitToRAM(ucDataValue,8);						//ʾ

	cs=1;												 					 //ͷHT1621
}


/*************************ȫʾ**************************************/

void Lcd_Display(unsigned char Num_1,Num_2,Num_3,Num_4)
{
	Num_1 |= C;
	Num_2 |= DP;
	Num_3 |= pH;
	Num_4 |= uS;


	cs=0;																	//ƬѡѡHT1621

	SendNBitToRAM(LCD_MODE_WRITE,3);			//ID
	SendAddrToRAM(0x00);									//͵ַ

	SendNBitToRAM(Num_1,8);								//һλ
	SendNBitToRAM(Num_2,8);								//ڶλ
	SendNBitToRAM(Num_3,8);								//λ
	SendNBitToRAM(Num_4,8);								//λ
	
	cs=1;												  				//ͷHT1621
}
